SystemOrganization addCategory: #'Glamour-Examples'!

Announcer subclass: #GLMAnnouncingCollection
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: 'JorgeRessia 11/6/2009 16:32'!
add: anObject

	collection add: anObject.
	self announce: GLMItemAdded! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: 'JorgeRessia 11/6/2009 16:35'!
at: anObject

	^collection at: anObject! !

!GLMAnnouncingCollection methodsFor: 'private' stamp: 'JorgeRessia 11/6/2009 16:35'!
collect: aBlock
	^collection collect: aBlock
	! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: 'JorgeRessia 11/6/2009 16:20'!
do: aBlock

	^collection do: aBlock! !

!GLMAnnouncingCollection methodsFor: 'private' stamp: 'JorgeRessia 11/6/2009 16:48'!
includes: anObject 
	^collection includes: anObject! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: 'TudorGirba 5/18/2011 12:23'!
initialize
	super initialize.
	collection := OrderedCollection new! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: 'JorgeRessia 11/6/2009 16:34'!
isCollection

	^true! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: 'tg 1/18/2010 21:15'!
printString
	^ collection printString ! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: 'JorgeRessia 11/6/2009 17:07'!
remove: anObject

	collection remove: anObject.
	self announce: GLMItemRemoved! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: 'tg 1/19/2010 11:28'!
removeLast

	collection removeLast.
	self announce: GLMItemRemoved! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: 'tg 1/19/2010 11:29'!
size
	^ collection size! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: 'JorgeRessia 11/6/2009 16:36'!
withIndexDo: aBlock

	^collection withIndexDo: aBlock! !

Announcement subclass: #GLMItemAdded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

Announcement subclass: #GLMItemRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

Object subclass: #GLMExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

GLMExamples subclass: #GLMBasicExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMBasicExamples commentStamp: '<historical>' prior: 0!
self open!

!GLMBasicExamples classSide methodsFor: 'accessing' stamp: 'tg 2/21/2010 01:06'!
title 
	^ 'Basic Examples'! !

!GLMBasicExamples methodsFor: 'browsers' stamp: 'TudorGirba 4/2/2011 07:51'!
accumulator
	<glmBrowser: 'Accumulator' input: '42'>
	"self new accumulator openOn: 42"
	| browser acc |
	browser := GLMTabulator new.
	acc := GLMAccumulator new.
	acc show: [:a | 
		a act: #inspect entitled: 'Inspect'.
		a title: [:x | x asString]. 
		a list title: 'List'; display: [:x | 1 to: x ].
		a text title: 'Text'; display: [:x | 'This is an editor on ', x printString ].
		].
	browser column: [:c | c row: #one span: 4; row: #two]; column: #three.
	browser transmit to: #one; andShow: [:a | 
		a list display: [:x | x to: 10 * x]].
	browser transmit from: #one; to: #two; andShow: [:a |
		a text display: [:x | 'You have selected ', x printString, '. Double cick to open to the right']].
	browser transmit from: #one->#strongSelection; to: #three; andShowIfNone: [:a |
		a custom: acc ].
	browser transmit from: #one; to: #three->#entityToSelect.
	browser transmit from: #three->#activeEntity; to: #one->#selection.
	^ browser
	! !

!GLMBasicExamples methodsFor: 'private' stamp: 'TudorGirba 2/5/2011 12:54'!
actionsFor: aPresentation 
	|actions|
	aPresentation isMultiple 
							ifTrue: [actions := (aPresentation selection) ifNil: [OrderedCollection new]]
							ifFalse: [actions := OrderedCollection with: aPresentation selection ].
	^ actions collect: [:i |
					(GLMGenericAction new) 
						action: [:each | self inform: 'Menu - Item', i printString]; 
						title: 'Menu - Item', i printString; 
						yourself ]! !

!GLMBasicExamples methodsFor: 'others' stamp: 'VeronicaUquillas 2/25/2011 13:41'!
allowAllNil
	<glmBrowser: 'Allowing all nil' input: '5'>
	"self new allowAllNil openOn: 5"
	| browser |
	 
	browser := GLMTabulator new.
	browser 
		column: [: c | c row: #one; row: #two];
		column: #details.
	browser showOn: #one; using: [
		browser tree 
			display:[ :x| 1 to: x ];
			allowDeselection ].
	browser showOn: #two; using: [
		browser tree 
			display: #(a b c);
			allowDeselection].
	browser showOn: #details; from: #one; from: #two; using: [
		browser text 
			display: [ :one :two | 'At least one is nil: ', one asString, '-', two asString];
			allowNil.
		browser text 
			display: [ :one :two | 'All are nil: ', one asString, '-',  two asString];
			allowAllNil ].
		
	"if you need initial display"
	browser transmit to: #details; andShow: [:a | 
		a text display: [:x | 'All are nil'  ] ].
	
	^ browser! !

!GLMBasicExamples methodsFor: 'others' stamp: 'tg 2/21/2010 01:10'!
allowNil
	<glmBrowser: 'Allowing nil' input: '42'>
	"self new allowNil openOn: 42"
	| browser | 
	browser := GLMTabulator new.
	browser 
		column: [: c | c row: #one; row: #two];
		column: #details.
	browser showOn: #one; using: [
		browser tree 
			display: #(1 2 3);
			allowDeselection ].
	browser showOn: #two; using: [
		browser tree 
			display: #(a b c);
			allowDeselection].
	browser showOn: #details; from: #one; from: #two; using: [
		browser text 
			display: [ :one :two | one asString, two asString];
			allowNil ].
	^ browser! !

!GLMBasicExamples methodsFor: 'actions examples' stamp: 'TudorGirba 11/26/2010 19:47'!
browserWithToolbar
	<glmBrowser: 'Toolbar' input: '$z'>
	"self new browserWithToolbar openOn: $z"

	| finder |
	finder := GLMFinder new.
	finder act: [:f | f inspect] icon: MenuIcons smallFindIcon entitled: 'Inspect with icon'.
	finder act: [:f | f inspect] entitled: 'Inspect without icon'.
	finder list
			title: 'List';
			display: [:each | $a to: each];
			dynamicActions: [:list | self actionsFor: list ];
			dynamicActionsOnSelection: [:list | self actionsFor: list ].
	^ finder! !

!GLMBasicExamples methodsFor: 'others' stamp: 'tg 10/25/2010 02:42'!
compoundTaggedTree
	<glmBrowser: 'Tags' input: '#(window help home)'>
	"self new compoundTaggedTree openOn: #(window help home)"
	|browser |
	browser := GLMTabulator new.
	browser column: #one.
	browser showOn: #one; using: [
		browser tree
			title: 'Combined Tags';
			tags: [:each | { {MenuIcons perform: (each, 'Icon') asSymbol . each asString }}].
		browser tree
			title: 'Image Tags';
			tags: [:each | { MenuIcons perform: (each, 'Icon') asSymbol}].
		browser tree
			title: 'Combined Tags - Filter by image';
			tags: [:each | 
				{ each == #help 
						ifTrue:[ {MenuIcons smallDeleteIcon . 'no ok' } ] 
						ifFalse:[ {MenuIcons smallOkIcon . each asString } ]} ];
			tagsFilter: [:each | 
				{ each == #help 
						ifTrue:[ MenuIcons smallDeleteIcon ] ifFalse:[ MenuIcons smallOkIcon ] } ].
		browser tree
			title: 'Combined Tags - Filter by label';
			tags: [:each | 
				{ {MenuIcons perform: (each, 'Icon') asSymbol.
					each == #help ifTrue:[ 'no ok' ] ifFalse:[ 'ok' ]}} ];
			tagsFilter: [:each | 
				{ each == #help ifTrue:[ 'no ok' ] ifFalse:[ 'ok' ] } ] ].
	^ browser! !

!GLMBasicExamples methodsFor: 'composite' stamp: 'tg 2/21/2010 01:12'!
differentComposites
	"self new differentComposites openOn: (1 to: 100)"
	<glmBrowser: 'Composite arrangements' input: '(1 to: 100)'>	
	| browser |
	browser := GLMTabulator new.
	browser row: [:r | 
		r column: #tabbed; column: #accordion; column: #stackedVertically] span: 4; row: #preview.
	browser transmit to: #tabbed; andShow: [:a | 
		a title: 'Tabs'.
		a list title: 'List'. a text title: 'Text' ].
	browser transmit to: #accordion; andShow: [:a | 
		a accordionArrangement.
		a title: 'Accordion'.
		a list title: 'List'. a text title: 'Text' ].
	browser transmit to: #stackedVertically; andShow: [:a | 
		a title: 'Stack'.
		a stackedVerticallyArrangement.
		a list title: 'List'. a text title: 'Text' ].
	browser transmit to: #preview; from: #tabbed; andShow: [:a | 
		a text display: [:x | x printString, ' from tabbed' ]].
	browser transmit to: #preview; from: #accordion; andShow: [:a | 
		a text display: [:x | x printString, ' from accordion' ]].
	browser transmit to: #preview; from: #stackedVertically; andShow: [:a | 
		a text display: [:x | x printString, ' from stacked vertically' ]].
	^ browser ! !

!GLMBasicExamples methodsFor: 'others' stamp: 'tg 2/21/2010 01:10'!
doubleClick
	<glmBrowser: 'Double click' input: '100'>
	"self new doubleClick openOn: 100"
	| browser |
	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser list display: [:x | 1 to: x]].
	browser showOn: #two; from: #one->#strongSelection; using: [
		browser list display: [:x | 1 to: x]].
	^ browser! !

!GLMBasicExamples methodsFor: 'explicit selection' stamp: 'VeronicaUquillas 5/27/2010 17:30'!
dropDownList
	"	| browser |
		browser := self new dropDownList.
		browser openOn: 5. "
	|browser |

	browser := GLMTabulator new.
	browser row: #one  size: 30; row: #two.
	browser showOn: #one; using: [
		browser dropDownList
			display: [:x | 1 to: x ];
			format: [:number | Text string: number printString attribute: TextColor red]].
	browser showOn: #two; from: #one; using: [
		browser list
			display: [:x | 1 to: x asNumber * 2]].
	^ browser! !

!GLMBasicExamples methodsFor: 'explicit selection' stamp: 'VeronicaUquillas 5/26/2010 14:48'!
dropDownListWithInitialValue
	"	| browser |
		browser := self new dropDownListWithInitialValue.
		browser openOn: 5.
		((browser paneNamed: #one) port: #selection) value: 12. "
	|browser |

	browser := GLMTabulator new.
	browser row: #one  size: 30; row: #two.
	browser showOn: #one; using: [
		browser dropDownList
			display: [:x | (1 to: x) + 10 ];
		   selectedIndex: 2 ].
	browser showOn: #two; from: #one; using: [
		browser list
			display: [:x | 1 to: x asNumber ]].
	^ browser! !

!GLMBasicExamples methodsFor: 'others' stamp: 'TudorGirba 4/19/2011 20:06'!
eyeseeBarDiagram
	<glmBrowser: 'EyeSee interactive bar chart' input: '#(5 2 10 6 12 8)'>
	"self new eyeseeBarDiagram openOn: #(5 2 10 6 12 8)."
	| browser |

	browser := GLMTabulator new.
	browser row: #one span: 3; row: #two.
	browser transmit to: #one; andShow: [:a |
	       a eyesee
			title: 'Sample bar chart';
			diagram: [:renderer :x |
	                       renderer verticalBarDiagram
						y: #yourself;
						models: x;
						width: 200;
						height: 150;
						baseAxisLine.
					renderer interaction popupText: #yourself ]].
	browser transmit from: #one; to: #two; andShow: [:a | 
		a text
			title: 'Preview'].
	^ browser! !

!GLMBasicExamples methodsFor: 'others' stamp: 'tg 4/1/2010 07:03'!
fixSizePanes
	<glmBrowser: 'Fix size pane' input: '5'>
	"self new fixSizePanes openOn: 1"
	| browser |
	browser := GLMTabulator new.
	browser row: #variable; row: #fix size: 20.
	browser transmit to: #fix; andShow: [ :a | a label display: 'Fix size'].
	browser showOn: #variable; using: [browser text display: 'Variable size'].
	^ browser ! !

!GLMBasicExamples methodsFor: 'others' stamp: 'tg 2/21/2010 01:10'!
interdependentPanes
	<glmBrowser: 'Two inter-dependent panes' input: '5'>
	"self new interdependentPanes openOn: 5"
	|browser |

	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser list
			display: [:x | 1 to: x * 3]].
	browser showOn: #two; from: #one; using: [
		browser list
			display: [:x | 1 to: x * 3]].
	browser showOn: #one; from: #two; using: [
		browser list
			display: [:x | 1 to: x * 3]].
	^ browser! !

!GLMBasicExamples methodsFor: 'explicit selection' stamp: 'tg 2/21/2010 01:12'!
listsWithUpdatedSelection
	"self new listsWithUpdatedSelection openOn: 10"
	<glmBrowser: 'Updated selection' input: '10'>
	| browser |
	browser := GLMTabulator new.
	browser column: #one; column: #two; column: #three.
	browser showOn: #one; using: [
		browser tree
			display: [:x | 1 to: x ]].
	browser showOn: #two; using: [
		browser tree
			display: [:x | 1 to: x + 2 ]].
	browser showOn: #three; using: [
		browser tree
			beMultiple;
			display: [:x | 1 to: x ]].
	browser sendTo: #two->#selection from: #one with: [:x | x + 2].
	browser sendTo: #one->#selection from: #two with: [:x | x - 2].
	browser sendTo: #three->#selection from: #two with: [:x | (1 to: (x - 2)) ].
	^ browser! !

!GLMBasicExamples methodsFor: 'others' stamp: 'TudorGirba 3/22/2011 13:12'!
magritte
	<glmBrowser: 'Magritte presentation' input: '''something'''>
	"self new magritte openOn: 'something'"
	| browser |
	browser := GLMTabulator new.
	browser row: #one.
	browser transmit to: #one; andShow:[ :a |
		a magritte
			title: 'Title';
			description: [:x | 
				| container |
				container := MAContainer new.
				container add: (
					MAStringDescription new
						label: 'Something';
						accessor: MAIdentityAccessor new;
						yourself).
				container ] ].
	^ browser! !

!GLMBasicExamples methodsFor: 'others' stamp: 'tg 7/2/2010 12:47'!
mondrianPainting
	<glmBrowser: 'Mondrian painting' input: '100'>
	"self new mondrianPainting openOn: 100"
	| browser items |
	browser := GLMTabulator withStatusbar.
	items := 50.
	browser act: [:b | 
		items := 10.
		(b paneNamed: #one) presentations first update ] entitled: 'Update'.
	browser act: [:b | 
		(b paneNamed: #one) inspect ] entitled: 'Inspect'.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser mondrian 
			title: 'Numbers in Mondrian tree';
			painting: [:view :number | 
			view shape label.
			view nodes: (1 to: items ).
			view edgesFrom: [:x | x // 3 ].
			view horizontalTreeLayout ]].
	browser showOn: #two; from: #one; using: [
		browser mondrian 
			title: 'Numbers in Mondrian list';
			painting: [:view :number |
				view shape rectangle width: 20; text: #printString; withoutBorder.
				view nodes: (1 to: number).
				view gridLayout ]].
	^ browser! !

!GLMBasicExamples methodsFor: 'others' stamp: 'TudorGirba 5/8/2011 23:08'!
morphIcons
	<glmBrowser: 'Morph icons' input: 'GLMUIThemeExtraIcons class selectors select: [:each | (each beginsWith: ''glamorous'') and: [(GLMUIThemeExtraIcons perform: each) isForm ]]'>
	"self new morphIcons openOn: (GLMUIThemeExtraIcons class selectors select: [:each | (each beginsWith: 'glamorous') and: [(GLMUIThemeExtraIcons perform: each) isForm ]])"
	| browser |
	browser := GLMTabulator new.
	browser column: #list; column: #preview.
	browser title: 'Glamorous Icons'.
	browser showOn: #list; using: [
		browser list ].
	browser showOn: #preview; from: #list; using: [
		browser morph
			display: [:symbol | 
				(GLMUIThemeExtraIcons perform: symbol) asMorph ] ].
	^ browser! !

!GLMBasicExamples methodsFor: 'explicit selection' stamp: 'tg 11/16/2009 15:11'!
multiInitialSelection
	"
		| browser |
		browser := self new multiInitialSelection.
		browser openOn: 5.
		(browser panes first port: #selection) value: #(2 5 3).
	"
	|browser |

	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser tree
			beMultiple;
			display: [:x | 1 to: x * 3]].
	browser showOn: #two; from: #one; using: [
		browser list ].
	^ browser! !

!GLMBasicExamples methodsFor: 'actions examples' stamp: 'TudorGirba 5/8/2011 23:02'!
multipleActions
	<glmBrowser: 'Multiple actions' input: '''This example shows how multiple actions are rendered.'''>
	"self new multipleActions openOn: 'This example shows how multiple actions are rendered.'"
	|browser |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a |
		a text 
			title: 'Example';
			selectionAct: [:text | text inspect ] on: $i entitled: 'Selection action';
			act: [:text | text inspect ] on: $i entitled: 'Action without icon';
			act: [:text | text inspect ] icon: GLMUIThemeExtraIcons glamorousInspect entitled: 'Action with icon' ].
	^ browser! !

!GLMBasicExamples methodsFor: 'searching and filtering' stamp: 'tg 11/19/2010 18:27'!
multipleFinderWithFilter
	<glmBrowser: 'Filter' input: '$a to: $z'>
	"self new multipleFinderWithFilter openOn: ($a to: $z)"

	| finder |	
	finder := GLMFinder new.
	finder list
			title: 'List';
			beMultiple;
			dynamicActions: [:list | self actionsFor: list];
			filterOn: [:text :each | Compiler evaluate: '| each | each := self. ', text for: each logged: false ].
	finder tree
			title: 'Tree';
			dynamicActions: [:list | self actionsFor: list];
			filterOn: [:text :each | Compiler evaluate: '| each | each := self. ', text for: each logged: false ].
	^ finder ! !

!GLMBasicExamples methodsFor: 'searching and filtering' stamp: 'tg 11/19/2010 18:27'!
multipleFinderWithFilterAndSearch
	<glmBrowser: 'Search' input: '$a to: $z'>
	"self new multipleFinderWithFilterAndSearch openOn: (1 to: 100)"

	| finder |	
	finder := GLMFinder new.
	finder list
			beMultiple;
			title: 'Simple';
			dynamicActions: [:list | self actionsFor: list].
	finder list
			title: 'With filter';
			beMultiple;
			dynamicActions: [:list | self actionsFor: list];
			filterOn: [:text :each | (Compiler evaluate: '[:each | ', text, ']') value: each].
	finder list
			title: 'With search';
			beMultiple;
			dynamicActions: [:list | self actionsFor: list];
			searchOn: [:text :each | (Compiler evaluate: '[:each | ', text, ']') value: each].
	^ finder ! !

!GLMBasicExamples methodsFor: 'text' stamp: 'TudorGirba 3/22/2011 13:18'!
populatePortAction
	<glmBrowser: 'Populate port action' input: 'String withAll: ''Select a piece of text and open on the next pane via the contextual menu or by pressing Modifier+o. Otherwise just open the complete copy of the current text on the next pane via the menu or by pressing Modifier+l.'''>
	"self new populatePortAction openOn: 'Select a piece of text and open on the next pane either with the overall button, or via the context menu'"
	| browser |
	browser := GLMFinder new.
	browser text
		selectionPopulate: #selection on: $o entitled: 'Open selection on next pane' with: [:text | text selectedText ];
		populate: #selection icon: GLMUIThemeExtraIcons glamorousRight on: $l entitled: 'Open complete text on next pane' with: [:text | text text ].
	^ browser ! !

!GLMBasicExamples methodsFor: 'actionlist' stamp: 'tg 2/21/2010 01:11'!
simpleActionList
	<glmBrowser: 'Action list' input: '#(1 2 3)'>	
	"self new simpleActionList openOn: #(1 2 3)"
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	browser showOn: #one; using: [
		browser actionList
			act: [:entity | Transcript show: entity ] entitled: 'Transcript';
			act: [:entity | entity inspect ] entitled: 'Inspect'].
	^ browser! !

!GLMBasicExamples methodsFor: 'others' stamp: 'TudorGirba 1/5/2011 17:20'!
simpleExpander
	<glmBrowser: 'Simple Expander' input: '#(a b c)'>
	"self new simpleExpander  openOn: #(a b c)"
	| browser |
	browser := GLMExpander new.
	browser show: [ :a | 
		a title: [:x | x ].
		a text title: 'text1'. 
		a text title: 'text2'.].
	^ browser! !

!GLMBasicExamples methodsFor: 'browsers' stamp: 'TudorGirba 4/2/2011 07:50'!
simpleFinder
	<glmBrowser: 'Finder' input: '100'>
	"self new simpleFinder openOn: 100"
	| finder |	
	finder := GLMFinder new.
	finder list display: [ :x | 1 to: x ].
	^ finder! !

!GLMBasicExamples methodsFor: 'actions examples' stamp: 'TudorGirba 3/8/2011 11:34'!
simpleFinderWithMenu
	<glmBrowser: 'Browser menu' input: '$z'>
	"self new simpleFinderWithMenu openOn: $z"

	| finder |
	finder := GLMFinder new variableSizePanes.
	finder list
			title: 'List';
			display: [:each | $a to: each];
			dynamicActionsOnSelection: [:list | self actionsFor: list ].
	^ finder! !

!GLMBasicExamples methodsFor: 'table' stamp: 'tg 11/19/2010 18:27'!
simpleTable
	<glmBrowser: 'Simple table' input: '100'>
	"self new simpleTable openOn: 1000"
	| finder |	
	finder := GLMFinder new.
	finder table
			display: [ :x | 1 to: x ]; 
			dynamicActions: [ :list | self actionsFor: list ];
			column: [:x | 'Numbers from 1 to ', x asString] evaluated: #asString;
			column: 'Even' evaluated: [ :each | each even asString ];
			column: 'Odd' evaluated: [ :each | each odd asString ].
	^ finder! !

!GLMBasicExamples methodsFor: 'explicit selection' stamp: 'tg 11/16/2009 15:11'!
singleInitialSelection
	"
		| browser |
		browser := self new singleInitialSelection.
		browser openOn: 5.
		(browser panes first port: #selection) value: 3.
	"
	|browser |

	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser tree
			display: [:x | 1 to: x];
			format: [:number | Text string: number printString attribute: TextColor red]].
	browser showOn: #two; from: #one; using: [
		browser list
			display: [:x | 1 to: x * 2]].
	^ browser! !

!GLMBasicExamples methodsFor: 'others' stamp: 'TudorGirba 12/2/2010 20:04'!
stacker
	<glmBrowser: 'Stacker' input: '5'>
	"self new stacker openOn: 5"
	
	| browser |
	browser := GLMStacker new.
	browser aPane: #x; aPane: #y.
	browser transmit to: #x; andShow: [ :a | 
		a title: 'x'.
		a list display: [:x | 1 to: x ]].
	browser transmit to: #y; andShow: [:a | 
		a title: '10 * x'.
		a list display: [:x |  1 to: (10*x )] ].
	^ browser ! !

!GLMBasicExamples methodsFor: 'others' stamp: 'VeronicaUquillas 5/20/2010 12:32'!
starBrowser
	"self new starBrowser openOn: { Boolean. String. #asString. #printString }"

	| browser accumulator |
	browser := GLMTabulator new.
	browser title: 'StarBrowser Light'.
	browser column: #tree; column: #browser span: 4.
	browser showOn: #tree; using: [ browser list ].
	accumulator := GLMAccumulator new.
	accumulator show: [ :a |
		a title: [:object | object printString ].
		a morph
			display: [ :object |
				| model |
				" create omnibrowser model "
				model := object isBehavior
					ifTrue: [ OBHierarchyBrowser onClass: object ]
					ifFalse: [ OBImplementorsBrowser root: (OBSelectorNode on: object) ].
				" create omnibrowser morph, but get rid of window "
				PanelMorph new
					layoutPolicy: ProportionalLayout new;
					addAllMorphs: (OBMorphBuilder build: model) paneMorphs;
					yourself ] ].
	browser transmit to: #browser; from: #tree->#strongSelection; andShowIfNone: [ :a |
		a custom: accumulator ].
	^ browser ! !

!GLMBasicExamples methodsFor: 'actions examples' stamp: 'TudorGirba 2/5/2011 12:55'!
staticAndDynamicMenu
	<glmBrowser: 'Menus' input: '$z'>
	"self new staticAndDynamicMenu openOn: $z"

	| finder |
	finder := GLMFinder new.
	finder list
			title: 'List';
			display: [:each | $a to: each];
			dynamicActionsOnSelection: [:list | self actionsFor: list ];
			selectionAct: [self inform: 'static action'] entitled: 'Static action';
			selectionAct: [self inform: 'static sub action'] entitled: 'Static sub action' categorized: 'Sub menu'.
	finder text
			title: 'Text';
			display: [:each | 'Character ', each asString];
			dynamicActionsOnSelection: [:text | OrderedCollection with: (GLMGenericAction new title: 'Print selection'; action: [Transcript show: text selection]; yourself) ];
			selectionAct: [self inform: 'Text static action'] entitled: 'Static action'.
	^ finder! !

!GLMBasicExamples methodsFor: 'actions examples' stamp: 'TudorGirba 11/26/2010 19:49'!
tableWithIcons
	<glmBrowser: 'Icons' input: '($A to: $z)'>
	"self new tableWithIcons openOn: ($A to: $z)"
	|browser |
	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser transmit to: #one; andShow: [ :a |
		a act: [:presentation | presentation inspect] entitled: 'Inspect'. 
		a table
			title: 'Table with actions';
			act: [:presentation | presentation inspect] entitled: 'Inspect'; 
			column: 'Character' evaluated: [ :each | each asString ];
			column: 'ASCII' evaluated: [ :each | each asInteger printString ];
			selectionAct: [:tree | tree inspect ] on: $i entitled: 'Inspect';
			icon: [:x | MenuIcons helpIcon ]].
	browser transmit to: #two; from: #one; andShow: [:a | a text ].
	^ browser! !

!GLMBasicExamples methodsFor: 'tabs examples' stamp: 'TudorGirba 4/2/2011 08:09'!
tabsWithDifferentActions
	<glmBrowser: 'Tabs with different actions' input: 42>
	"self new tabsWithDifferentActions openOn: 42"
	
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [:a | 
		a text
			display: 'Tab with multiple actions. Switch between tabs to check the toolbars on the right';
			title: 'Tab with multiple actions';
			act: [:x | x inspect] icon: GLMUIThemeExtraIcons glamorousInspect entitled: 'Inspect with icon';
			act: [:x | x printString inspect] icon: GLMUIThemeExtraIcons glamorousBrowse entitled: 'Print it and inspect with icon';
			act: [:x | x inspect] entitled: 'Inspect without icon';
			act: [:x | x printString inspect] entitled: 'Print it and inspect without icon'.
		a text 
			display: 'Tab without actions. Switch between tabs to check the toolbars on the right';
			title: 'Tab without actions' ].
	^ browser! !

!GLMBasicExamples methodsFor: 'tabs examples' stamp: 'TudorGirba 5/4/2011 14:01'!
tabsWithDifferentLabels
	<glmBrowser: 'Tabs with different labels' input: '1'>
	"self new tabsWithDifferentLabels openOn: 1"
	
	| finder |
	finder := GLMFinder new.
	(1 to: 3) do: [:i | 
		finder text
			title: i printString;
			display: [:x | i printString].
		finder text
			titleIcon: MenuIcons smallFindIcon;
			display: [:x | i printString]
	].
	
	^ finder! !

!GLMBasicExamples methodsFor: 'others' stamp: 'tg 11/2/2010 23:06'!
taggedTree
	"self new taggedTree openOn: #(1 2 3 4 5)"
	|browser |

	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser transmit to: #one; andShow: [ :a |
		a tree
			tags: [:each | 
				{each even ifTrue: ['even'] ifFalse: ['odd'].
				each even ifTrue: ['x'] ifFalse: ['y']}
				]].
	browser transmit to: #two; from: #one; andShow: [ :a |
		a text
			display: [:x | 'You have selected ', x printString ]].
	^ browser! !

!GLMBasicExamples methodsFor: 'text' stamp: 'tg 11/2/2010 23:05'!
textPortsExamples
	"
		self new textPortsExamples openOn: 'Type and select to see the results previewed.'
	"
	| browser |
	browser := GLMTabulator new.
	browser row: #main; row: [:r | r column: #selected; column: #full].
	browser transmit to: #main; andShow: [:a | a text].
	browser transmit to: #selected; from: #main->#selectedText; andShow: [:a | a text].
	browser transmit to: #full; from: #main->#text; andShow: [:a | a text].
	^ browser! !

!GLMBasicExamples methodsFor: 'text' stamp: 'tg 4/15/2010 23:40'!
textSelectionInterval
	<glmBrowser: 'Text selection' input: '(1 to: 100)'>
	"	|browser |
		browser := self new textSelectionInterval.
		browser openOn: (1 to: 100).
		((browser paneNamed: #start) port: #selection) value: 2.
		((browser paneNamed: #end) port: #selection) value: 5.		
	"
	| browser |
	browser := GLMTabulator new.
	browser row: [ :r | r column: #start; column: #end ]; row: #text.
	browser transmit to: #start; andShow: [ :a | a list title: 'Start' ].
	browser transmit to: #end; andShow: [ :a | a list title: 'End' ].
	browser transmit to: #text; andShow: [ :a | 
		a text 
			title: 'Text with selection';
			display: 'some piece of text to test the selection interval on.'].
	browser transmit to: #text->#selectionInterval; from: #start; from: #end; when: [:s :e | s notNil & e notNil] ; transformed: [ :s :e | s to: e ].
"	browser transmit to: #start->#selection; from: #text->#selectionInterval; transformed: [:interval | interval first].
	browser transmit to: #end->#selection; from: #text->#selectionInterval; transformed: [:interval | interval last].
"	^ browser! !

!GLMBasicExamples methodsFor: 'others' stamp: 'tg 11/2/2010 23:04'!
threeInterdependentPanes
	<glmBrowser: 'Three inter-dependent panes' input: '5'>
	"self new threeInterdependentPanes openOn: 5"
	|browser |

	browser := GLMTabulator new.
	browser column: #one; column: #two; column: #three.
	browser transmit to: #one; andShow: [ :a |
		a tree
			display: [:x | 1 to: x]].
	browser transmit to: #two; from: #one; andShow: [ :a | 
		a tree
			display: [:x | 1 to: x*2]].
	browser transmit to: #three; from: #two; andShow: [ :a | 
		a tree
			display: [:x | 1 to: x*3];
			populate: #focus on: $f entitled: 'Focus' with: [:list | list selection] ].
	browser transmit toOutside: #focus; from: #three->#focus.
	browser transmit to: #one->#selection; from: #outer->#focus.
	browser transmit to: #two->#selection; from: #outer->#focus.
	^ browser! !

!GLMBasicExamples methodsFor: 'others' stamp: 'tg 11/2/2010 22:50'!
treeWithAmountFiltering
	<glmBrowser: 'Smart lists' input: '(1 to: 10000)'>
	"self new treeWithAmountFiltering openOn: (1 to: 10000)"
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | 
		a tree
			tags: [ :each | {each even printString} ];
			showOnly: 50 ].
	^ browser ! !

!GLMBasicExamples methodsFor: 'explicit selection' stamp: 'tg 11/2/2010 21:05'!
treeWithChildrenByLevel
	<glmBrowser: 'Tree with children by level' input: '(1 to: 5)'>
	"
		self new treeWithChildrenByLevel openOn: #(1 2 3 4 5)
	"
	|browser |

	browser := GLMTabulator new.
	browser column: #one; column: [:c | c row: #two; row: #three].
	browser transmit to: #one; andShow: [ :a |
		browser tree
			title: 'Tree';
			children: [:item :x :level | level > 1 ifTrue: [#()] ifFalse: [1 to: item ] ] "Children must return a collection"].
	browser transmit to: #two; from: #one; andShow: [:a | 
		a text title: 'Selection preview' ].
	browser transmit to: #three; from: #one->#selectionPath; andShow: [:a | 
		a text title: 'Selection path preview'].
	^ browser! !

!GLMBasicExamples methodsFor: 'others' stamp: 'tg 11/2/2010 22:51'!
treeWithExpansion
	<glmBrowser: 'Tree with expansion' input: '#(($a $b $c $d) ($e $f) ($g $h $i $j ($l $m $n)))'>
	"self new treeWithExpansion openOn: #(($a $b $c $d) ($e $f) ($g $h $i $j ($l $m $n)))"
	|browser |
	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser transmit to: #one; andShow: [:a |
		a tree
			title: 'No expansion';
			children: [:x :i | x asString size > 1 ifTrue: [x] ifFalse: [OrderedCollection new] ].
		a tree
			title: 'Roots expanded';
			rootsExpanded;
			children: [:x :i | x asString size > 1 ifTrue: [x] ifFalse: [OrderedCollection new] ].
		a tree
			title: 'All expanded';
			allExpanded;
			children: [:x :i | x asString size > 1 ifTrue: [x] ifFalse: [OrderedCollection new] ] ].
	browser transmit to: #two; from: #one; andShow: [ :a | a text ].
	^ browser! !

!GLMBasicExamples methodsFor: 'explicit selection' stamp: 'tg 11/2/2010 22:53'!
treeWithInitialSelection
	"
		| browser |
		browser := self new treeWithInitialSelection. 
		browser openOn: {
			#first->{$a->{}. $c->{}. $d->{}}.
			#second->{$e->{}. $f->{}}. 
			#third->{$h->{}}
		}.
		(browser panes first port: #selection) value: $a->{}.
	"
	|browser |

	browser := GLMTabulator new.
	browser column: #one; column: [:c | c row: #two; row: #three].
	browser transmit to: #one; andShow: [ :a |
		a tree
			title: 'first tree';
			children: [:x | x value ].
		a tree
			title: 'second tree';
			children: [:x | x value ]].
	browser transmit to: #two; from: #one; andShow: [ :a | browser text title: 'Selection preview' ].
	browser transmit to: #three; from: #one->#selectionPath; andShow: [ :a | a text title: 'Selection path preview'].
	^ browser! !

!GLMBasicExamples methodsFor: 'actions examples' stamp: 'tg 11/20/2010 20:11'!
treeWithMenu
	<glmBrowser: 'Tree with menu' input: '#(($a $b $c $d) ($e $f) ($g $h $i $j $l))'>
	"self new treeWithMenu openOn: #(($a $b $c $d) ($e $f) ($g $h $i $j $l))"
	|browser |
	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser transmit to: #one; andShow: [ :a |
		a tree
			children: [:x :i | x asString size > 1 ifTrue: [x] ifFalse: [OrderedCollection new] ];
			selectionAct: [:tree | tree inspect ] on: $i entitled: 'Inspect';
			icon: [:x | MenuIcons helpIcon ]].
	browser transmit to: #two; from: #one; andShow: [:a | a text ].
	^ browser! !

!GLMBasicExamples methodsFor: 'explicit selection' stamp: 'DamienCassou 5/2/2011 08:16'!
treeWithTags
	<glmBrowser: 'Tree withTags' input: '(1 to: 10)'>
	"
		self new treeWithTags openOn: #(1 2 3 4 5 6 7 8 9 10)
	"
	|browser model|
	model := Dictionary new.
	model at: #some put: #(1 2 3 4).
	model at: #even put: #(2 6 8).
	model at: #odd put: #(3 7 9).
	
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a |
		browser tree
			display: [model keys];  
			children: [:key | key isNumber ifFalse: [model at: key] ];
			tags: [:item | item isNumber ifTrue: [item even ifTrue: [#('even')] ifFalse: [#('odd')]] ifFalse: [#()]]].  
	^ browser! !

!GLMBasicExamples methodsFor: 'explicit selection' stamp: 'DamienCassou 5/11/2011 08:39'!
treeWithTagsMoreLevels
	<glmBrowser: 'Tree withTags more levels' input: '(1 to: 10)'>
	"
		self new treeWithTagsMoreLevels openOn: #(1 2 3 4 5 6 7 8 9 10)
	"
	|browser model|
	model := Dictionary new.
	model at: #some put: #(1 2 3 4).
	model at: #even put: #(2 6 8).
	model at: #odd put: #(3 7 9).
	
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a |
		browser tree
			display: [model keys];
			children: [:child | child isSymbol
								ifTrue: [Array with: ((model at: child) select: [:c | c < 4]) with: ((model at: child) select: [:c | c >= 4])]
								ifFalse: [child isCollection
											ifTrue: [child]
											ifFalse: [#()]]];
			tags: [:item | Array streamContents: [:stream |
					item isNumber ifTrue: [
						stream nextPut: (item even ifTrue: ['even'] ifFalse: ['odd']).
						stream nextPut: (item < 4 ifTrue: ['<4'] ifFalse: ['>=4' ])]]]].  
	^ browser! !

!GLMBasicExamples methodsFor: 'updating' stamp: 'TudorGirba 3/22/2011 13:14'!
updateableBrowser
	<glmBrowser: 'Updateable browser' input: '|collection|
	collection := GLMAnnouncingCollection new.
	collection add: 1; add: 2; add: 3.
	collection'>
	"
	|collection|
	collection := GLMAnnouncingCollection new.
	collection add: 1; add: 2; add: 3.
	self new updateableBrowser openOn: collection."
	
	| browser |
	browser := GLMTabulator new.
	browser column: #automatic; column: #menu.
	browser act: [:b | b entity add: (b entity size + 1) ] entitled: 'Add an item in the collection'.
	browser act: [:b | b entity removeLast ] entitled: 'Remove last item from the collection'.
	browser act: [:b | b update ] entitled: 'Update complete browser'.
	browser transmit to: #automatic; andShow: [ :a |
		a title: 'Updated automatically'.
		a stackedArrangement.
		a list title: [:x | 'List: ', x size printString ];
			shouldValidate: true;
			updateOn: GLMItemAdded from: #yourself;
			updateOn: GLMItemRemoved from: #yourself.
		a text title: 'Text';
			updateOn: GLMItemAdded from: #yourself;
			updateOn: GLMItemRemoved from: #yourself .
		a mondrian title: 'Mondrian';
			updateOn: GLMItemAdded from: #yourself;
			updateOn: GLMItemRemoved from: #yourself;
			painting: [:view :entity | 
				view shape label.
				view nodes: entity ] ].
	browser transmit to: #menu; andShow: [ :a |
		a title: 'Updated via menu'.
		a stackedArrangement.
		a list title: 'List';
			shouldValidate: true;
			act: [:p | p update] entitled: 'Update'.
		a text title: 'Text'; act: [:p | p update] entitled: 'Update'.
		a mondrian title: 'Mondrian';
			act: [:p | p update] entitled: 'Update';
			painting: [:view :entity | 
				view shape label.
				view nodes: entity ] ].
	^ browser! !

!GLMBasicExamples methodsFor: 'browsers' stamp: 'TudorGirba 4/9/2011 20:37'!
validator
	<glmBrowser: 'Validator' input: '100'>
	"self new validator openOn: 100"

	| finder validator |
	finder := GLMFinder new.
	validator := GLMValidator new.
	validator validator: 'Ok' act: [:x | ].
	validator show: [:a | a list display: [:x | 1 to: x ]].
	finder show: [:a | a custom: validator].
	^ finder! !

!GLMBasicExamples methodsFor: 'browsers' stamp: 'TudorGirba 4/9/2011 20:40'!
validatorDynamic
	<glmBrowser: 'Dynamic validator' input: '100'>
	"self new validatorDynamic openOn: 100"

	| finder validator |
	finder := GLMFinder new.
	validator := GLMValidator new.
	validator validator: 'Ok' act: [:x | ].
	validator show: [:a | 
		a dynamic display: [:x |
			GLMListPresentation new display: [:y | 1 to: y]
			]  
		].
	finder show: [:a | a custom: validator].
	^ finder! !

!GLMBasicExamples methodsFor: 'browsers' stamp: 'TudorGirba 4/12/2011 12:28'!
wizard
	<glmBrowser: 'Wizard' input: '100'>
	"self new wizard openOn: 100"

	| wizard |
	wizard := GLMWizard new.
	(wizard genericStep: #step)
		show: [:a | 
		a list
			display: [:list | 1 to: 100] 
		] ;
		name: 'Wizard pane';
		size: 2.
	^ wizard! !

!GLMExamples classSide methodsFor: 'accessing' stamp: 'TudorGirba 5/8/2011 22:47'!
allExamples
	^ Pragma allNamed: #glmBrowser:input: in: self.! !

!GLMExamples classSide methodsFor: 'accessing' stamp: 'TudorGirba 5/8/2011 22:47'!
browser
	| browser |
	browser := GLMTabulator new.
	browser title: self title.
	browser
		column: #titles;
		column: #example span: 4.
	(browser transmit)
		to: #titles;
		andShow: [ :a | 
					(a list)
						title: 'Examples';
						display: [ :list | list ];
						sorted: [ :x :y | (x argumentAt: 1) < (y argumentAt: 1) ];
						format: [ :each | each argumentAt: 1 ] ].
	(browser transmit)
		to: #example;
		from: #titles;
		andShow: [ :a | 
					(a dynamic)
						title: 'Browser';
						presentation: [ :some :each | some custom: (self exampleBrowserForPragma: each) ].
					(a text)
						title: 'Source code';
						act: [ :text :pragma | StandardToolSet browse: self selector: pragma selector ]
							icon: GLMUIThemeExtraIcons glamorousBrowse
							entitled: 'Browse';
						forSmalltalk: self;
						display: [ :pragma | self sourceCodeAt: pragma selector ] ].
	^ browser! !

!GLMExamples classSide methodsFor: 'accessing' stamp: 'TudorGirba 5/8/2011 22:47'!
exampleBrowserForPragma: each
	^ (self new perform: each selector) startOn: (Compiler evaluate: (each argumentAt: 2) logged: false)! !

!GLMExamples classSide methodsFor: 'rendering' stamp: 'TudorGirba 5/8/2011 22:47'!
open
	^ self browser openOn: self allExamples! !

!GLMExamples classSide methodsFor: 'accessing' stamp: 'tg 2/21/2010 01:06'!
title
	^ 'Examples'! !

GLMExamples subclass: #GLMOtherExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMOtherExamples commentStamp: '<historical>' prior: 0!
self open!

!GLMOtherExamples methodsFor: 'other examples' stamp: 'TudorGirba 1/6/2011 01:22'!
expander
	"self new expander openOn: Collection withAllSubclasses"
	| browser expander |
	browser := GLMTabulator new.
	browser title: 'Example'.
	expander := GLMExpander new.
	expander title: 'Methods'.
	expander display: [:class | class methods ].
	expander show: [ :a | 
		a title: [:x | x selector ].
		a text 
			display: #getSource].
	browser column: #classes; column: #methods.
	browser transmit to: #classes; andShow: [:a | 
		a list title: 'Classes' ].
	browser transmit to: #methods; from: #classes; andShow: [:a | 
		a custom: expander ].
	^ browser
! !

!GLMOtherExamples methodsFor: 'file examples' stamp: 'tg 11/16/2009 15:11'!
fileExplorer
	<glmBrowser: 'File Explorer' input: 'FileDirectory default'>
	"self new fileExplorer openOn: FileDirectory default"
	| browser |
	browser := GLMTabulator new.
	browser 
		column: #folders;
		column: [ :col | col row: #files span: 2; row: #preview ] span: 2. 
	browser showOn: #folders; using: [
		browser tree 
			title: 'Folders'; 
			children: [ :fd | fd directoryNames collect: [ :each | FileDirectory on: fd pathName, fd pathNameDelimiter asString, each ] ]; 
			format: [ :folder | folder localName ] ].
	browser showOn: #files; from: #folders; using: [
		browser list 
			format: [ :fd | fd localName ]; 
			display: [ :fd | fd fileNames collect: [:each | FileDirectory on: fd pathName, fd pathNameDelimiter asString, each ] ] ].
	browser showOn: #preview; from: #files; using: [
		browser text
			display: [ :file | file fullName ] ].
	^ browser! !

!GLMOtherExamples methodsFor: 'file examples' stamp: 'tg 11/13/2009 01:48'!
fileFinder
	<glmBrowser: 'File Finder' input: 'FileDirectory default'>
	"self new fileFinder openOn: FileDirectory default"

	| browser |
	browser := GLMFinder new.
	browser list
		display: [ :fd | fd entries collect: [:each | 
				FileDirectory on: fd pathName, fd pathNameDelimiter asString, each name]];
		format: [ :fd | fd localName ];
		when: [ :fd | fd directoryEntry isDirectory ].
	browser text
		display: [ :fd | fd fullName ];
		when: [ :fd | fd directoryEntry isDirectory not ].
	^ browser! !

!GLMOtherExamples methodsFor: 'pier examples' stamp: 'TudorGirba 3/9/2011 17:30'!
glamourEditor
	"self new glamourEditor openOn: 'browser := GLMTabulator new.
browser startOn: ''asdasd'''"
	| browser |
	browser := GLMTabulator new.
	browser title: 'Glamour Editor'.
	browser row: #browser span: 10; row: #script span: 4.
	browser transmit to: #script; andShow: [ :a |
		a text
			forSmalltalk;
			title: 'Glamour script';
			display: [:script | script ];
			populate: #selection icon: GLMUIThemeExtraIcons glamorousAccept on: $o entitled: 'Generate browser' with: [:text | text text ] ].
	browser transmit to: #browser; from: #script; andShow: [ :a |
		a dynamic
			display: [:script | 
				[(Compiler evaluate: 'browser := self.', script for: nil logged: false)] on: Error do: [:err | GLMTextPresentation new title: 'Error'; display: err printString] ]].
	^ browser! !

!GLMOtherExamples methodsFor: 'pier examples' stamp: 'TudorGirba 3/9/2011 17:22'!
mondrianEasel
	"self new mondrianEasel openOn: 'view shape label.
view nodes: (1 to: 40).
view edgesFrom: [:x | x // 3 ].
view treeLayout'"
	| browser |
	browser := GLMTabulator new.
	browser title: 'Simple Mondrian Easel'.
	browser row: #painting span: 10; row: #script span: 4.
	browser transmit to: #script; andShow: [ :a |
		a text
			forSmalltalk;
			title: 'Mondrian script';
			display: [:script | script ];
			populate: #selection icon: GLMUIThemeExtraIcons glamorousAccept on: $o entitled: 'Generate View' with: [:text | text text ] ].
	browser transmit to: #painting; from: #script; andShow: [ :a |
		a mondrian
			title: 'Mondrian painting';
			painting: [ :view :script | 
						(Compiler evaluate: 'view := self.', script for: view logged: false)  ];
			act: [:m | m canvas exportAsPNG] entitled: 'Export as PNG';
			act: [:m | 
				m canvas root decreaseZoom.
				m canvas  changed ] 
			icon: MondrianIcons mondrianZoomOut
			entitled: 'Zoom out';
			act: [:m | 
				m canvas root increaseZoom.
				m canvas root updateWindow ] 
			icon: MondrianIcons mondrianZoomIn 
			entitled: 'Zoom in'].
	^ browser! !

!GLMOtherExamples methodsFor: 'pier examples' stamp: 'tg 11/13/2009 01:46'!
pierFinder
	"
		self new pierFinder openOn: PRKernel instances anyOne root.
	"
	| browser |
	browser := GLMFinder new.
	browser list
		display: [:each | each enumerator contents];
		format: [:each | each title];
		title: 'Navigation'.
	browser magritte title: 'Editor'.
	browser mondrian
			title: 'Tree';
			painting: [:view :each | 
				view nodeShape: (MORectangleShape withBorder height: [:x | x plainText size // 10]).
				view nodes: each enumerator everything contents.
				view edgesFrom: #parent.
				view treeLayout].
	^ browser! !

!GLMOtherExamples methodsFor: 'pier examples' stamp: 'tg 11/16/2009 15:11'!
pierTreeEditor

	"
		self new pierTreeEditor openOn: PRKernel instances anyOne root.
	"

	| browser |
	browser := GLMTabulator new.
	browser column: #navigation; column: #editor span: 4.
	browser showOn: #navigation; using: [
		browser tree
			children: [:each | each enumerator contents];
			format: [:each | each title ];
			title: 'Navigation'.
	].
	browser showOn: #editor; from: #navigation; using: [
		browser magritte
			title: 'Editor'.
	].
	^ browser ! !

Object subclass: #GLMSTBrowserExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMSTBrowserExample methodsFor: 'accessing' stamp: 'lr 2/19/2010 09:45'!
browser
	"
	self new browser openOn: (BrowserEnvironment new forPackageNames: #('Glamour'))
	"

	| browser |

	browser := GLMTabulator new.
	browser row: [ :row | 
		row 
			column: #category;
			column: #class;
			column: #protocol;
			column: #selector ].
	browser row: #source.
	
	" categories "
	self categoriesOn: browser.
	self classesOn: browser.
	self protocolsOn: browser.
	self selectorsOn: browser.
	self sourceOn: browser.
	
	^ browser! !

!GLMSTBrowserExample methodsFor: 'building' stamp: 'lr 2/27/2009 15:09'!
categoriesOn: browser
	browser showOn: #category; using: [
		browser list
			display: [ :environment | environment categories ] ]! !

!GLMSTBrowserExample methodsFor: 'building' stamp: 'DamienCassou 5/8/2011 17:15'!
classesOn: browser
	browser showOn: #class; from: #outer -> #entity; from: #category; using: [
		browser list
			title: 'Instance';
			display: [ :environment :category | 
				((environment classes select: [ :each | each isMeta not ])
					select: [ :each | each category = category ])];
			sorted: [ :a :b | a name < b name ];
			format: [ :class | class name ].
		browser list
			title: 'Class';
			display: [ :environment :category | 
				((environment classes select: [ :each | each isMeta ])
					select: [ :each | each theNonMetaClass category = category ])];
			sorted: [ :a :b | a name < b name ] ;
			format: [ :class | class theNonMetaClass name ] ]! !

!GLMSTBrowserExample methodsFor: 'accessing' stamp: 'lr 2/27/2009 10:35'!
model
	^ BrowserEnvironment new forPackageNamed: 'Glamour'! !

!GLMSTBrowserExample methodsFor: 'building' stamp: 'DamienCassou 5/8/2011 17:18'!
protocolsOn: browser
	browser showOn: #protocol; from: #outer -> #entity; from: #class; using: [
		browser list
			when: [ :environment :class | class notNil ];
			display: [ :environment :class | (environment protocolsFor: class) ];
			sorted ]! !

!GLMSTBrowserExample methodsFor: 'building' stamp: 'DamienCassou 5/8/2011 17:19'!
selectorsOn: browser
	browser showOn: #selector; from: #outer -> #entity; from: #class; from: #protocol; using: [
		browser list
			useExplicitNotNil;
			when: [ :environment :class :protocol | class notNil and: [ protocol notNil ] ];
			display: [ :environment :class :protocol | (environment selectorsFor: protocol in: class)  ];
			sorted.
		browser list
			useExplicitNotNil;
			when: [ :environment :class :protocol | class notNil and: [ protocol isNil ] ];
			display: [ :environment :class :protocol | (environment selectorsForClass: class) ];
			sorted ]! !

!GLMSTBrowserExample methodsFor: 'building' stamp: 'lr 2/19/2010 09:47'!
sourceOn: browser
	browser showOn: #source; from: #category; from: #class; from: #selector; using: [
		browser text
			title: 'Source';
			useExplicitNotNil;
			when: [ :category :class :selector | class notNil and: [ selector notNil ] ];
			display: [ :category :class :selector | class sourceCodeAt: selector ifAbsent: [ String new ] ].
		browser text
			title: 'Source';
			useExplicitNotNil;
			when: [ :category :class :selector | class notNil and: [ selector isNil ] ];
			display: [ :category :class :selector | class definition ].
		browser mondrian
			title: 'Complexity';
			useExplicitNotNil;
			painting: [ :view :category :class :selector |
				view nodeShape 
					height: [ :model | model linesOfCode min: 50 max: 5 ];
					width: [ :model | model instVarNames size + 5 ];
					fillColor: [ :model | model = class ifTrue: [ Color red ] ifFalse: [ Color white ] ].
				view nodes: (((Smalltalk organization listAtCategoryNamed: category)
					collect: [ :each | Smalltalk classNamed: each ])
					reject: [ :each | each isTrait ]).
				view edgesFrom: [ :each | each superclass ].
				view treeLayout ];
			when: [ :category :class :selector | category notNil ] ]! !
